Index: kernel/generic/src/ipc/ipc.c
===================================================================
--- kernel/generic/src/ipc/ipc.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/ipc/ipc.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -66,8 +66,8 @@
 answerbox_t *ipc_phone_0 = NULL;
 
-static slab_cache_t *call_slab;
-static slab_cache_t *answerbox_slab;
-
-slab_cache_t *phone_slab = NULL; 
+static slab_cache_t *call_cache;
+static slab_cache_t *answerbox_cache;
+
+slab_cache_t *phone_cache = NULL; 
 
 /** Initialize a call structure.
@@ -87,19 +87,18 @@
 }
 
-void ipc_call_hold(call_t *call)
-{
-	atomic_inc(&call->refcnt);
-}
-
-void ipc_call_release(call_t *call)
-{
-	if (atomic_predec(&call->refcnt) == 0) {
-		if (call->buffer)
-			free(call->buffer);
-		if (call->caller_phone)
-			kobject_put(call->caller_phone->kobject);
-		slab_free(call_slab, call);
-	}
-}
+static void call_destroy(void *arg)
+{
+	call_t *call = (call_t *) arg;
+
+	if (call->buffer)
+		free(call->buffer);
+	if (call->caller_phone)
+		kobject_put(call->caller_phone->kobject);
+	slab_free(call_cache, call);
+}
+
+static kobject_ops_t call_kobject_ops = {
+	.destroy = call_destroy
+};
 
 /** Allocate and initialize a call structure.
@@ -116,21 +115,18 @@
 call_t *ipc_call_alloc(unsigned int flags)
 {
-	call_t *call = slab_alloc(call_slab, flags);
-	if (call) {
-		_ipc_call_init(call);
-		ipc_call_hold(call);
-	}
+	call_t *call = slab_alloc(call_cache, flags);
+	if (!call)
+		return NULL;
+	kobject_t *kobj = (kobject_t *) malloc(sizeof(kobject_t), flags);
+	if (!kobj) {
+		slab_free(call_cache, call);
+		return NULL;
+	}
+
+	_ipc_call_init(call);
+	kobject_initialize(kobj, KOBJECT_TYPE_CALL, call, &call_kobject_ops);
+	call->kobject = kobj;
 	
 	return call;
-}
-
-/** Deallocate a call structure.
- *
- * @param call Call structure to be freed.
- *
- */
-void ipc_call_free(call_t *call)
-{
-	ipc_call_release(call);
 }
 
@@ -214,5 +210,5 @@
 int ipc_call_sync(phone_t *phone, call_t *request)
 {
-	answerbox_t *mybox = slab_alloc(answerbox_slab, 0);
+	answerbox_t *mybox = slab_alloc(answerbox_cache, 0);
 	ipc_answerbox_init(mybox, TASK);
 	
@@ -222,5 +218,5 @@
 	int rc = ipc_call(phone, request);
 	if (rc != EOK) {
-		slab_free(answerbox_slab, mybox);
+		slab_free(answerbox_cache, mybox);
 		return rc;
 	}
@@ -269,5 +265,5 @@
 	assert(!answer || request == answer);
 	
-	slab_free(answerbox_slab, mybox);
+	slab_free(answerbox_cache, mybox);
 	return rc;
 }
@@ -290,5 +286,5 @@
 		/* This is a forgotten call and call->sender is not valid. */
 		spinlock_unlock(&call->forget_lock);
-		ipc_call_free(call);
+		kobject_put(call->kobject);
 		return;
 	} else {
@@ -705,5 +701,5 @@
 	 * must hold a reference to it.
 	 */
-	ipc_call_hold(call);
+	kobject_add_ref(call->kobject);
 
 	spinlock_unlock(&call->forget_lock);
@@ -714,5 +710,5 @@
 	SYSIPC_OP(request_forget, call);
 
-	ipc_call_release(call);
+	kobject_put(call->kobject);
 }
 
@@ -822,5 +818,5 @@
 	SYSIPC_OP(answer_process, call);
 
-	ipc_call_free(call);
+	kobject_put(call->kobject);
 	goto restart;
 }
@@ -839,4 +835,17 @@
 {
 	ipc_irq_unsubscribe(&TASK->answerbox, cap->handle);
+	return true;
+}
+
+static bool call_cap_cleanup_cb(cap_t *cap, void *arg)
+{
+	/*
+	 * Here we just free the capability and release the kobject.
+	 * The kernel answers the remaining calls elsewhere in ipc_cleanup().
+	 */
+	kobject_t *kobj = cap_unpublish(cap->task, cap->handle,
+	    KOBJECT_TYPE_CALL);
+	kobject_put(kobj);
+	cap_free(cap->task, cap->handle);
 	return true;
 }
@@ -878,4 +887,8 @@
 	ipc_kbox_cleanup();
 #endif
+
+	/* Destroy all call capabilities */
+	caps_apply_to_kobject_type(TASK, KOBJECT_TYPE_CALL, call_cap_cleanup_cb,
+	    NULL);
 	
 	/* Answer all messages in 'calls' and 'dispatched_calls' queues */
@@ -893,9 +906,9 @@
 void ipc_init(void)
 {
-	call_slab = slab_cache_create("call_t", sizeof(call_t), 0, NULL,
+	call_cache = slab_cache_create("call_t", sizeof(call_t), 0, NULL,
 	    NULL, 0);
-	phone_slab = slab_cache_create("phone_t", sizeof(phone_t), 0, NULL,
+	phone_cache = slab_cache_create("phone_t", sizeof(phone_t), 0, NULL,
 	    NULL, 0);
-	answerbox_slab = slab_cache_create("answerbox_t", sizeof(answerbox_t),
+	answerbox_cache = slab_cache_create("answerbox_t", sizeof(answerbox_t),
 	    0, NULL, NULL, 0);
 }
Index: kernel/generic/src/ipc/ipcrsc.c
===================================================================
--- kernel/generic/src/ipc/ipcrsc.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/ipc/ipcrsc.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -137,31 +137,4 @@
 #include <mm/slab.h>
 
-/** Find call_t * in call table according to callid.
- *
- * @todo Some speedup (hash table?)
- *
- * @param callid Userspace hash of the call. Currently it is the call structure
- *               kernel address.
- *
- * @return NULL on not found, otherwise pointer to the call structure.
- *
- */
-call_t *get_call(sysarg_t callid)
-{
-	call_t *result = NULL;
-	
-	irq_spinlock_lock(&TASK->answerbox.lock, true);
-	
-	list_foreach(TASK->answerbox.dispatched_calls, ab_link, call_t, call) {
-		if ((sysarg_t) call == callid) {
-			result = call;
-			break;
-		}
-	}
-	
-	irq_spinlock_unlock(&TASK->answerbox.lock, true);
-	return result;
-}
-
 static bool phone_reclaim(kobject_t *kobj)
 {
@@ -180,5 +153,5 @@
 {
 	phone_t *phone = (phone_t *) arg;
-	slab_free(phone_slab, phone);
+	slab_free(phone_cache, phone);
 }
 
@@ -200,5 +173,5 @@
 	cap_handle_t handle = cap_alloc(task);
 	if (handle >= 0) {
-		phone_t *phone = slab_alloc(phone_slab, FRAME_ATOMIC);
+		phone_t *phone = slab_alloc(phone_cache, FRAME_ATOMIC);
 		if (!phone) {
 			cap_free(TASK, handle);
@@ -208,5 +181,5 @@
 		if (!kobject) {
 			cap_free(TASK, handle);
-			slab_free(phone_slab, phone);
+			slab_free(phone_cache, phone);
 			return ENOMEM;
 		}
Index: kernel/generic/src/ipc/irq.c
===================================================================
--- kernel/generic/src/ipc/irq.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/ipc/irq.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -294,5 +294,5 @@
 	/* Free up the IRQ code and associated structures. */
 	code_free(irq->notif_cfg.code);
-	slab_free(irq_slab, irq);
+	slab_free(irq_cache, irq);
 }
 
@@ -308,10 +308,11 @@
  * @param ucode   Uspace pointer to top-half IRQ code.
  *
- * @return  IRQ capability handle.
- * @return  Negative error code.
+ * @param[out] uspace_handle  Uspace pointer to IRQ capability handle
+ *
+ * @return  Error code.
  *
  */
 int ipc_irq_subscribe(answerbox_t *box, inr_t inr, sysarg_t imethod,
-    irq_code_t *ucode)
+    irq_code_t *ucode, cap_handle_t *uspace_handle)
 {
 	if ((inr < 0) || (inr > last_inr))
@@ -333,5 +334,11 @@
 		return handle;
 	
-	irq_t *irq = (irq_t *) slab_alloc(irq_slab, FRAME_ATOMIC);
+	int rc = copy_to_uspace(uspace_handle, &handle, sizeof(cap_handle_t));
+	if (rc != EOK) {
+		cap_free(TASK, handle);
+		return rc;
+	}
+
+	irq_t *irq = (irq_t *) slab_alloc(irq_cache, FRAME_ATOMIC);
 	if (!irq) {
 		cap_free(TASK, handle);
@@ -342,5 +349,5 @@
 	if (!kobject) {
 		cap_free(TASK, handle);
-		slab_free(irq_slab, irq);
+		slab_free(irq_cache, irq);
 		return ENOMEM;
 	}
@@ -371,5 +378,5 @@
 	cap_publish(TASK, handle, kobject);
 	
-	return handle;
+	return EOK;
 }
 
Index: kernel/generic/src/ipc/kbox.c
===================================================================
--- kernel/generic/src/ipc/kbox.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/ipc/kbox.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -206,8 +206,9 @@
  * cleanup code.
  *
- * @return Phone capability handle on success, or negative error code.
- *
- */
-int ipc_connect_kbox(task_id_t taskid)
+ * @param[out] out_phone  Phone capability handle on success.
+ * @return Error code.
+ *
+ */
+int ipc_connect_kbox(task_id_t taskid, cap_handle_t *out_phone)
 {
 	irq_spinlock_lock(&tasks_lock, true);
@@ -231,9 +232,24 @@
 	}
 	
-	if (task->kb.finished != false) {
+	if (task->kb.finished) {
 		mutex_unlock(&task->kb.cleanup_lock);
 		return EINVAL;
 	}
 	
+	/* Create a kbox thread if necessary. */
+	if (task->kb.thread == NULL) {
+		thread_t *kb_thread = thread_create(kbox_thread_proc, NULL, task,
+		    THREAD_FLAG_NONE, "kbox");
+		
+		if (!kb_thread) {
+			mutex_unlock(&task->kb.cleanup_lock);
+			return ENOMEM;
+		}
+		
+		task->kb.thread = kb_thread;
+		thread_ready(kb_thread);
+	}
+	
+	/* Allocate a new phone. */
 	cap_handle_t phone_handle = phone_alloc(TASK);
 	if (phone_handle < 0) {
@@ -248,23 +264,7 @@
 	(void) ipc_phone_connect(phone_obj->phone, &task->kb.box);
 	
-	if (task->kb.thread != NULL) {
-		mutex_unlock(&task->kb.cleanup_lock);
-		return phone_handle;
-	}
-	
-	/* Create a kbox thread */
-	thread_t *kb_thread = thread_create(kbox_thread_proc, NULL, task,
-	    THREAD_FLAG_NONE, "kbox");
-	if (!kb_thread) {
-		mutex_unlock(&task->kb.cleanup_lock);
-		return ENOMEM;
-	}
-	
-	task->kb.thread = kb_thread;
-	thread_ready(kb_thread);
-	
 	mutex_unlock(&task->kb.cleanup_lock);
-	
-	return phone_handle;
+	*out_phone = phone_handle;
+	return EOK;
 }
 
Index: kernel/generic/src/ipc/sysipc.c
===================================================================
--- kernel/generic/src/ipc/sysipc.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/ipc/sysipc.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -53,4 +53,5 @@
 #include <print.h>
 #include <macros.h>
+#include <cap/cap.h>
 
 #define STRUCT_TO_USPACE(dst, src)  copy_to_uspace((dst), (src), sizeof(*(src)))
@@ -286,10 +287,10 @@
 #endif
 
-		ipc_call_hold(call);
+		kobject_add_ref(call->kobject);
 		rc = ipc_call_sync(kobj->phone, call);
 		spinlock_lock(&call->forget_lock);
 		bool forgotten = call->forget;
 		spinlock_unlock(&call->forget_lock);
-		ipc_call_release(call);
+		kobject_put(call->kobject);
 
 #ifdef CONFIG_UDEBUG
@@ -306,5 +307,5 @@
 				 * deallocation.
 				 */
-				ipc_call_free(call);
+				kobject_put(call->kobject);
 			} else {
 				/*
@@ -323,5 +324,5 @@
 	
 	memcpy(data->args, call->data.args, sizeof(data->args));
-	ipc_call_free(call);
+	kobject_put(call->kobject);
 	kobject_put(kobj);
 	
@@ -347,5 +348,5 @@
 /** Make a fast asynchronous call over IPC.
  *
- * This function can only handle four arguments of payload, but is faster than
+ * This function can only handle three arguments of payload, but is faster than
  * the generic function sys_ipc_call_async_slow().
  *
@@ -355,20 +356,20 @@
  * @param arg2     Service-defined payload argument.
  * @param arg3     Service-defined payload argument.
- * @param arg4     Service-defined payload argument.
- *
- * @return Call hash on success.
- * @return IPC_CALLRET_FATAL in case of a fatal error.
+ * @param label    User-defined label.
+ *
+ * @return EOK on success.
+ * @return Negative error code on error.
  *
  */
 sysarg_t sys_ipc_call_async_fast(sysarg_t handle, sysarg_t imethod,
-    sysarg_t arg1, sysarg_t arg2, sysarg_t arg3, sysarg_t arg4)
+    sysarg_t arg1, sysarg_t arg2, sysarg_t arg3, sysarg_t label)
 {
 	kobject_t *kobj = kobject_get(TASK, handle, KOBJECT_TYPE_PHONE);
 	if (!kobj)
-		return IPC_CALLRET_FATAL;
+		return ENOENT;
 	
 	if (check_call_limit(kobj->phone)) {
 		kobject_put(kobj);
-		return IPC_CALLRET_FATAL;
+		return ELIMIT;
 	}
 	
@@ -378,5 +379,4 @@
 	IPC_SET_ARG2(call->data, arg2);
 	IPC_SET_ARG3(call->data, arg3);
-	IPC_SET_ARG4(call->data, arg4);
 	
 	/*
@@ -385,4 +385,7 @@
 	 */
 	IPC_SET_ARG5(call->data, 0);
+
+	/* Set the user-defined label */
+	call->data.label = label;
 	
 	int res = request_preprocess(call, kobj->phone);
@@ -394,5 +397,5 @@
 	
 	kobject_put(kobj);
-	return (sysarg_t) call;
+	return EOK;
 }
 
@@ -401,17 +404,19 @@
  * @param handle  Phone capability for the call.
  * @param data    Userspace address of call data with the request.
+ * @param label   User-defined label.
  *
  * @return See sys_ipc_call_async_fast().
  *
  */
-sysarg_t sys_ipc_call_async_slow(sysarg_t handle, ipc_data_t *data)
+sysarg_t sys_ipc_call_async_slow(sysarg_t handle, ipc_data_t *data,
+    sysarg_t label)
 {
 	kobject_t *kobj = kobject_get(TASK, handle, KOBJECT_TYPE_PHONE);
 	if (!kobj)
-		return IPC_CALLRET_FATAL;
+		return ENOENT;
 
 	if (check_call_limit(kobj->phone)) {
 		kobject_put(kobj);
-		return IPC_CALLRET_FATAL;
+		return ELIMIT;
 	}
 
@@ -420,8 +425,11 @@
 	    sizeof(call->data.args));
 	if (rc != 0) {
-		ipc_call_free(call);
+		kobject_put(call->kobject);
 		kobject_put(kobj);
 		return (sysarg_t) rc;
 	}
+
+	/* Set the user-defined label */
+	call->data.label = label;
 	
 	int res = request_preprocess(call, kobj->phone);
@@ -433,5 +441,5 @@
 	
 	kobject_put(kobj);
-	return (sysarg_t) call;
+	return EOK;
 }
 
@@ -440,6 +448,6 @@
  * Common code for both the fast and the slow version.
  *
- * @param callid   Hash of the call to forward.
- * @param handle   Phone capability to use for forwarding.
+ * @param chandle  Call handle of the forwarded call.
+ * @param phandle  Phone handle to use for forwarding.
  * @param imethod  New interface and method to use for the forwarded call.
  * @param arg1     New value of the first argument for the forwarded call.
@@ -458,12 +466,14 @@
  *
  */
-static sysarg_t sys_ipc_forward_common(sysarg_t callid, sysarg_t handle,
+static sysarg_t sys_ipc_forward_common(sysarg_t chandle, sysarg_t phandle,
     sysarg_t imethod, sysarg_t arg1, sysarg_t arg2, sysarg_t arg3,
     sysarg_t arg4, sysarg_t arg5, unsigned int mode, bool slow)
 {
-	call_t *call = get_call(callid);
-	if (!call)
+	kobject_t *ckobj = cap_unpublish(TASK, chandle, KOBJECT_TYPE_CALL);
+	if (!ckobj)
 		return ENOENT;
 	
+	call_t *call = ckobj->call;
+
 	ipc_data_t old;
 	bool need_old = answer_need_old(call);
@@ -474,6 +484,6 @@
 	int rc;
 
-	kobject_t *kobj = kobject_get(TASK, handle, KOBJECT_TYPE_PHONE);
-	if (!kobj) {
+	kobject_t *pkobj = kobject_get(TASK, phandle, KOBJECT_TYPE_PHONE);
+	if (!pkobj) {
 		rc = ENOENT;
 		goto error;
@@ -521,5 +531,5 @@
 	}
 	
-	rc = ipc_forward(call, kobj->phone, &TASK->answerbox, mode);
+	rc = ipc_forward(call, pkobj->phone, &TASK->answerbox, mode);
 	if (rc != EOK) {
 		after_forward = true;
@@ -527,5 +537,7 @@
 	}
 
-	kobject_put(kobj);
+	cap_free(TASK, chandle);
+	kobject_put(ckobj);
+	kobject_put(pkobj);
 	return EOK;
 
@@ -538,6 +550,9 @@
 		ipc_answer(&TASK->answerbox, call);
 
-	if (kobj)
-		kobject_put(kobj);
+	/* Republish the capability so that the call does not get lost. */
+	cap_publish(TASK, chandle, ckobj);
+
+	if (pkobj)
+		kobject_put(pkobj);
 	return rc;
 }
@@ -552,6 +567,6 @@
  * arguments are not set and these values are ignored.
  *
- * @param callid   Hash of the call to forward.
- * @param handle   Phone handle to use for forwarding.
+ * @param chandle  Call handle of the call to forward.
+ * @param phandle  Phone handle to use for forwarding.
  * @param imethod  New interface and method to use for the forwarded call.
  * @param arg1     New value of the first argument for the forwarded call.
@@ -562,9 +577,9 @@
  *
  */
-sysarg_t sys_ipc_forward_fast(sysarg_t callid, sysarg_t handle,
+sysarg_t sys_ipc_forward_fast(sysarg_t chandle, sysarg_t phandle,
     sysarg_t imethod, sysarg_t arg1, sysarg_t arg2, unsigned int mode)
 {
-	return sys_ipc_forward_common(callid, handle, imethod, arg1, arg2, 0, 0,
-	    0, mode, false); 
+	return sys_ipc_forward_common(chandle, phandle, imethod, arg1, arg2, 0,
+	    0, 0, mode, false);
 }
 
@@ -578,13 +593,13 @@
  * and arg5, respectively, to ARG3, ARG4 and ARG5, respectively.
  *
- * @param callid  Hash of the call to forward.
- * @param handle  Phone handle to use for forwarding.
- * @param data    Userspace address of the new IPC data.
- * @param mode    Flags that specify mode of the forward operation.
+ * @param chandle  Call handle of the call to forward.
+ * @param phandle  Phone handle to use for forwarding.
+ * @param data     Userspace address of the new IPC data.
+ * @param mode     Flags that specify mode of the forward operation.
  *
  * @return 0 on succes, otherwise an error code.
  *
  */
-sysarg_t sys_ipc_forward_slow(sysarg_t callid, sysarg_t handle,
+sysarg_t sys_ipc_forward_slow(sysarg_t chandle, sysarg_t phandle,
     ipc_data_t *data, unsigned int mode)
 {
@@ -595,8 +610,8 @@
 		return (sysarg_t) rc;
 	
-	return sys_ipc_forward_common(callid, handle,
+	return sys_ipc_forward_common(chandle, phandle,
 	    IPC_GET_IMETHOD(newdata), IPC_GET_ARG1(newdata),
 	    IPC_GET_ARG2(newdata), IPC_GET_ARG3(newdata),
-	    IPC_GET_ARG4(newdata), IPC_GET_ARG5(newdata), mode, true); 
+	    IPC_GET_ARG4(newdata), IPC_GET_ARG5(newdata), mode, true);
 }
 
@@ -606,25 +621,23 @@
  * than the generic sys_ipc_answer().
  *
- * @param callid Hash of the call to be answered.
- * @param retval Return value of the answer.
- * @param arg1   Service-defined return value.
- * @param arg2   Service-defined return value.
- * @param arg3   Service-defined return value.
- * @param arg4   Service-defined return value.
+ * @param chandle  Call handle to be answered.
+ * @param retval   Return value of the answer.
+ * @param arg1     Service-defined return value.
+ * @param arg2     Service-defined return value.
+ * @param arg3     Service-defined return value.
+ * @param arg4     Service-defined return value.
  *
  * @return 0 on success, otherwise an error code.
  *
  */
-sysarg_t sys_ipc_answer_fast(sysarg_t callid, sysarg_t retval,
-    sysarg_t arg1, sysarg_t arg2, sysarg_t arg3, sysarg_t arg4)
-{
-	/* Do not answer notification callids */
-	if (callid & IPC_CALLID_NOTIFICATION)
-		return 0;
-	
-	call_t *call = get_call(callid);
-	if (!call)
+sysarg_t sys_ipc_answer_fast(sysarg_t chandle, sysarg_t retval, sysarg_t arg1,
+    sysarg_t arg2, sysarg_t arg3, sysarg_t arg4)
+{
+	kobject_t *kobj = cap_unpublish(TASK, chandle, KOBJECT_TYPE_CALL);
+	if (!kobj)
 		return ENOENT;
 	
+	call_t *call = kobj->call;
+
 	ipc_data_t saved_data;
 	bool saved;
@@ -650,4 +663,8 @@
 	
 	ipc_answer(&TASK->answerbox, call);
+
+	kobject_put(kobj);
+	cap_free(TASK, chandle);
+
 	return rc;
 }
@@ -655,20 +672,18 @@
 /** Answer an IPC call.
  *
- * @param callid Hash of the call to be answered.
- * @param data   Userspace address of call data with the answer.
+ * @param chandle Call handle to be answered.
+ * @param data    Userspace address of call data with the answer.
  *
  * @return 0 on success, otherwise an error code.
  *
  */
-sysarg_t sys_ipc_answer_slow(sysarg_t callid, ipc_data_t *data)
-{
-	/* Do not answer notification callids */
-	if (callid & IPC_CALLID_NOTIFICATION)
-		return 0;
-	
-	call_t *call = get_call(callid);
-	if (!call)
+sysarg_t sys_ipc_answer_slow(sysarg_t chandle, ipc_data_t *data)
+{
+	kobject_t *kobj = cap_unpublish(TASK, chandle, KOBJECT_TYPE_CALL);
+	if (!kobj)
 		return ENOENT;
 	
+	call_t *call = kobj->call;
+
 	ipc_data_t saved_data;
 	bool saved;
@@ -682,10 +697,19 @@
 	int rc = copy_from_uspace(&call->data.args, &data->args, 
 	    sizeof(call->data.args));
-	if (rc != 0)
+	if (rc != 0) {
+		/*
+		 * Republish the capability so that the call does not get lost.
+		 */
+		cap_publish(TASK, chandle, kobj);
 		return rc;
+	}
 	
 	rc = answer_preprocess(call, saved ? &saved_data : NULL);
 	
 	ipc_answer(&TASK->answerbox, call);
+
+	kobject_put(kobj);
+	cap_free(TASK, chandle);
+
 	return rc;
 }
@@ -720,9 +744,5 @@
  *                 for explanation.
  *
- * @return Hash of the call.
- *         If IPC_CALLID_NOTIFICATION bit is set in the hash, the
- *         call is a notification. IPC_CALLID_ANSWERED denotes an
- *         answer.
- *
+ * @return Negative error code on error.
  */
 sysarg_t sys_ipc_wait_for_call(ipc_data_t *calldata, uint32_t usec,
@@ -743,7 +763,11 @@
 	udebug_stoppable_end();
 #endif
-	
-	if (!call)
-		return 0;
+
+	if (!call) {
+		ipc_data_t data = {0};
+		data.cap_handle = CAP_NIL;
+		STRUCT_TO_USPACE(calldata, &data);
+		return EOK;
+	}
 	
 	if (call->flags & IPC_CALL_NOTIF) {
@@ -751,9 +775,11 @@
 		call->data.phone = (void *) call->priv;
 		
+		call->data.flags = IPC_CALL_NOTIF;
+		call->data.cap_handle = CAP_NIL;
+
 		STRUCT_TO_USPACE(calldata, &call->data);
+		kobject_put(call->kobject);
 		
-		ipc_call_free(call);
-		
-		return ((sysarg_t) call) | IPC_CALLID_NOTIFICATION;
+		return EOK;
 	}
 	
@@ -762,12 +788,15 @@
 		
 		if (call->flags & IPC_CALL_DISCARD_ANSWER) {
-			ipc_call_free(call);
+			kobject_put(call->kobject);
 			goto restart;
 		}
+
+		call->data.flags = IPC_CALL_ANSWERED;
+		call->data.cap_handle = CAP_NIL;
 		
 		STRUCT_TO_USPACE(calldata, &call->data);
-		ipc_call_free(call);
+		kobject_put(call->kobject);
 		
-		return ((sysarg_t) call) | IPC_CALLID_ANSWERED;
+		return EOK;
 	}
 	
@@ -775,27 +804,47 @@
 		goto restart;
 	
-	/* Include phone address('id') of the caller in the request,
-	 * copy whole call->data, not only call->data.args */
-	if (STRUCT_TO_USPACE(calldata, &call->data)) {
-		/*
-		 * The callee will not receive this call and no one else has
-		 * a chance to answer it. Reply with the EPARTY error code.
-		 */
-		ipc_data_t saved_data;
-		bool saved;
-		
-		if (answer_need_old(call)) {
-			memcpy(&saved_data, &call->data, sizeof(call->data));
-			saved = true;
-		} else
-			saved = false;
-		
-		IPC_SET_RETVAL(call->data, EPARTY);
-		(void) answer_preprocess(call, saved ? &saved_data : NULL);
-		ipc_answer(&TASK->answerbox, call);
-		return 0;
-	}
-	
-	return (sysarg_t) call;
+	int rc;
+	cap_handle_t handle = cap_alloc(TASK);
+	if (handle < 0) {
+		rc = handle;
+		goto error;
+	}
+	
+	call->data.cap_handle = handle;
+
+	/*
+	 * Include phone hash of the caller in the request, copy the whole
+	 * call->data, not only call->data.args.
+	 */
+	rc = STRUCT_TO_USPACE(calldata, &call->data);
+	if (rc != EOK)
+		goto error;
+
+	kobject_add_ref(call->kobject);
+	cap_publish(TASK, handle, call->kobject);
+	return EOK;
+
+error:
+	if (handle >= 0)
+		cap_free(TASK, handle);
+
+	/*
+	 * The callee will not receive this call and no one else has a chance to
+	 * answer it. Reply with the EPARTY error code.
+	 */
+	ipc_data_t saved_data;
+	bool saved;
+
+	if (answer_need_old(call)) {
+		memcpy(&saved_data, &call->data, sizeof(call->data));
+		saved = true;
+	} else
+		saved = false;
+
+	IPC_SET_RETVAL(call->data, EPARTY);
+	(void) answer_preprocess(call, saved ? &saved_data : NULL);
+	ipc_answer(&TASK->answerbox, call);
+
+	return rc;
 }
 
@@ -815,15 +864,17 @@
  * @param ucode   Uspace pointer to the top-half pseudocode.
  *
- * @return IRQ kernel object capability
+ * @param[out] uspace_handle  Uspace pointer to IRQ kernel object capability
+ *
  * @return EPERM
  * @return Error code returned by ipc_irq_subscribe().
  *
  */
-sysarg_t sys_ipc_irq_subscribe(inr_t inr, sysarg_t imethod, irq_code_t *ucode)
+sysarg_t sys_ipc_irq_subscribe(inr_t inr, sysarg_t imethod, irq_code_t *ucode,
+	cap_handle_t *uspace_handle)
 {
 	if (!(perm_get(TASK) & PERM_IRQ_REG))
 		return EPERM;
 	
-	return ipc_irq_subscribe(&TASK->answerbox, inr, imethod, ucode);
+	return ipc_irq_subscribe(&TASK->answerbox, inr, imethod, ucode, uspace_handle);
 }
 
@@ -846,20 +897,29 @@
 }
 
-#ifdef __32_BITS__
-
-/** Syscall connect to a task by ID (32 bits)
- *
- * @return Phone id on success, or negative error code.
- *
- */
-sysarg_t sys_ipc_connect_kbox(sysarg64_t *uspace_taskid)
+/** Syscall connect to a task by ID
+ *
+ * @return Error code.
+ *
+ */
+sysarg_t sys_ipc_connect_kbox(task_id_t *uspace_taskid, cap_handle_t *uspace_phone)
 {
 #ifdef CONFIG_UDEBUG
-	sysarg64_t taskid;
-	int rc = copy_from_uspace(&taskid, uspace_taskid, sizeof(sysarg64_t));
-	if (rc != 0)
-		return (sysarg_t) rc;
-	
-	return ipc_connect_kbox((task_id_t) taskid);
+	task_id_t taskid;
+	cap_handle_t phone;
+	
+	int rc = copy_from_uspace(&taskid, uspace_taskid, sizeof(task_id_t));
+	if (rc == EOK) {
+		rc = ipc_connect_kbox((task_id_t) taskid, &phone);
+	}
+	
+	if (rc == EOK) {
+		rc = copy_to_uspace(uspace_phone, &phone, sizeof(cap_handle_t));
+		if (rc != EOK) {
+			// Clean up the phone on failure.
+			sys_ipc_hangup(phone);
+		}
+	}
+	
+	return (sysarg_t) rc;
 #else
 	return (sysarg_t) ENOTSUP;
@@ -867,24 +927,4 @@
 }
 
-#endif  /* __32_BITS__ */
-
-#ifdef __64_BITS__
-
-/** Syscall connect to a task by ID (64 bits)
- *
- * @return Phone id on success, or negative error code.
- *
- */
-sysarg_t sys_ipc_connect_kbox(sysarg_t taskid)
-{
-#ifdef CONFIG_UDEBUG
-	return ipc_connect_kbox((task_id_t) taskid);
-#else
-	return (sysarg_t) ENOTSUP;
-#endif
-}
-
-#endif  /* __64_BITS__ */
-
 /** @}
  */
Index: kernel/generic/src/log/log.c
===================================================================
--- kernel/generic/src/log/log.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/log/log.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -294,5 +294,5 @@
  */
 sysarg_t sys_klog(sysarg_t operation, void *buf, size_t size,
-    sysarg_t level)
+    sysarg_t level, size_t *uspace_nread)
 {
 	char *data;
@@ -376,5 +376,6 @@
 				return (sysarg_t) rc;
 			
-			return copied;
+			return copy_to_uspace(uspace_nread, &copied, sizeof(copied));
+			return EOK;
 		default:
 			return (sysarg_t) ENOTSUP;
Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/mm/as.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -90,5 +90,5 @@
  *
  */
-static slab_cache_t *as_slab;
+static slab_cache_t *as_cache;
 
 /** ASID subsystem lock.
@@ -131,5 +131,5 @@
 	as_arch_init();
 	
-	as_slab = slab_cache_create("as_t", sizeof(as_t), 0,
+	as_cache = slab_cache_create("as_t", sizeof(as_t), 0,
 	    as_constructor, as_destructor, SLAB_CACHE_MAGDEFERRED);
 	
@@ -153,5 +153,5 @@
 as_t *as_create(unsigned int flags)
 {
-	as_t *as = (as_t *) slab_alloc(as_slab, 0);
+	as_t *as = (as_t *) slab_alloc(as_cache, 0);
 	(void) as_create_arch(as, 0);
 	
@@ -254,5 +254,5 @@
 #endif
 	
-	slab_free(as_slab, as);
+	slab_free(as_cache, as);
 }
 
@@ -833,5 +833,5 @@
 			    btree_node_t, leaf_link);
 			
-			if ((cond = (bool) node->keys)) {
+			if ((cond = (node->keys != 0))) {
 				uintptr_t ptr = node->key[node->keys - 1];
 				size_t node_size =
Index: kernel/generic/src/mm/slab.c
===================================================================
--- kernel/generic/src/mm/slab.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/mm/slab.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -818,10 +818,8 @@
 }
 
-/* Print list of slabs
- *
- */
+/* Print list of caches */
 void slab_print_list(void)
 {
-	printf("[slab name       ] [size  ] [pages ] [obj/pg] [slabs ]"
+	printf("[cache name      ] [size  ] [pages ] [obj/pg] [slabs ]"
 	    " [cached] [alloc ] [ctl]\n");
 	
Index: kernel/generic/src/proc/scheduler.c
===================================================================
--- kernel/generic/src/proc/scheduler.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/proc/scheduler.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -163,5 +163,5 @@
 			irq_spinlock_unlock(&CPU->lock, false);
 			THREAD->saved_fpu_context =
-			    (fpu_context_t *) slab_alloc(fpu_context_slab, 0);
+			    (fpu_context_t *) slab_alloc(fpu_context_cache, 0);
 			
 			/* We may have switched CPUs during slab_alloc */
Index: kernel/generic/src/proc/task.c
===================================================================
--- kernel/generic/src/proc/task.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/proc/task.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -79,5 +79,5 @@
 static task_id_t task_counter = 0;
 
-static slab_cache_t *task_slab;
+static slab_cache_t *task_cache;
 
 /* Forward declarations. */
@@ -93,5 +93,5 @@
 	TASK = NULL;
 	avltree_create(&tasks_tree);
-	task_slab = slab_cache_create("task_t", sizeof(task_t), 0,
+	task_cache = slab_cache_create("task_t", sizeof(task_t), 0,
 	    tsk_constructor, tsk_destructor, 0);
 }
@@ -206,5 +206,5 @@
 task_t *task_create(as_t *as, const char *name)
 {
-	task_t *task = (task_t *) slab_alloc(task_slab, 0);
+	task_t *task = (task_t *) slab_alloc(task_cache, 0);
 	task_create_arch(task);
 	
@@ -295,5 +295,5 @@
 	as_release(task->as);
 	
-	slab_free(task_slab, task);
+	slab_free(task_cache, task);
 }
 
Index: kernel/generic/src/proc/thread.c
===================================================================
--- kernel/generic/src/proc/thread.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/proc/thread.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -103,8 +103,8 @@
 static thread_id_t last_tid = 0;
 
-static slab_cache_t *thread_slab;
+static slab_cache_t *thread_cache;
 
 #ifdef CONFIG_FPU
-slab_cache_t *fpu_context_slab;
+slab_cache_t *fpu_context_cache;
 #endif
 
@@ -169,5 +169,5 @@
 	thread->saved_fpu_context = NULL;
 #else /* CONFIG_FPU_LAZY */
-	thread->saved_fpu_context = slab_alloc(fpu_context_slab, kmflags);
+	thread->saved_fpu_context = slab_alloc(fpu_context_cache, kmflags);
 	if (!thread->saved_fpu_context)
 		return -1;
@@ -199,5 +199,5 @@
 #ifdef CONFIG_FPU
 		if (thread->saved_fpu_context)
-			slab_free(fpu_context_slab, thread->saved_fpu_context);
+			slab_free(fpu_context_cache, thread->saved_fpu_context);
 #endif
 		return -1;
@@ -225,5 +225,5 @@
 #ifdef CONFIG_FPU
 	if (thread->saved_fpu_context)
-		slab_free(fpu_context_slab, thread->saved_fpu_context);
+		slab_free(fpu_context_cache, thread->saved_fpu_context);
 #endif
 	
@@ -241,9 +241,9 @@
 	
 	atomic_set(&nrdy, 0);
-	thread_slab = slab_cache_create("thread_t", sizeof(thread_t), 0,
+	thread_cache = slab_cache_create("thread_t", sizeof(thread_t), 0,
 	    thr_constructor, thr_destructor, 0);
 	
 #ifdef CONFIG_FPU
-	fpu_context_slab = slab_cache_create("fpu_context_t",
+	fpu_context_cache = slab_cache_create("fpu_context_t",
 	    sizeof(fpu_context_t), FPU_CONTEXT_ALIGN, NULL, NULL, 0);
 #endif
@@ -341,5 +341,5 @@
     thread_flags_t flags, const char *name)
 {
-	thread_t *thread = (thread_t *) slab_alloc(thread_slab, 0);
+	thread_t *thread = (thread_t *) slab_alloc(thread_cache, 0);
 	if (!thread)
 		return NULL;
@@ -457,5 +457,5 @@
 	 */
 	task_release(thread->task);
-	slab_free(thread_slab, thread);
+	slab_free(thread_cache, thread);
 }
 
@@ -974,5 +974,5 @@
 				 * We can safely deallocate it.
 				 */
-				slab_free(thread_slab, thread);
+				slab_free(thread_cache, thread);
 				free(kernel_uarg);
 				
Index: kernel/generic/src/sysinfo/sysinfo.c
===================================================================
--- kernel/generic/src/sysinfo/sysinfo.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/sysinfo/sysinfo.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -53,5 +53,5 @@
 
 /** Sysinfo SLAB cache */
-static slab_cache_t *sysinfo_item_slab;
+static slab_cache_t *sysinfo_item_cache;
 
 /** Sysinfo lock */
@@ -98,5 +98,5 @@
 void sysinfo_init(void)
 {
-	sysinfo_item_slab = slab_cache_create("sysinfo_item_t",
+	sysinfo_item_cache = slab_cache_create("sysinfo_item_t",
 	    sizeof(sysinfo_item_t), 0, sysinfo_item_constructor,
 	    sysinfo_item_destructor, SLAB_CACHE_MAGDEFERRED);
@@ -204,5 +204,5 @@
 		
 		*psubtree =
-		    (sysinfo_item_t *) slab_alloc(sysinfo_item_slab, 0);
+		    (sysinfo_item_t *) slab_alloc(sysinfo_item_cache, 0);
 		assert(*psubtree);
 		
@@ -268,5 +268,5 @@
 			
 			sysinfo_item_t *item =
-			    (sysinfo_item_t *) slab_alloc(sysinfo_item_slab, 0);
+			    (sysinfo_item_t *) slab_alloc(sysinfo_item_cache, 0);
 			assert(item);
 			
